# NetworkLoadBalancersApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                                                                                                                                                 | HTTP request                                                                                                           | Description                             |
| ---------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------- | --------------------------------------- |
| [**datacenters\_networkloadbalancers\_delete**](#datacenters_networkloadbalancers_delete)                                                                              | **DELETE** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}                                    | Delete Network Load Balancers           |
| [**datacenters\_networkloadbalancers\_find\_by\_network\_load\_balancer\_id**](#datacenters_networkloadbalancers_find_by_network_load_balancer_id)                     | **GET** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}                                       | Retrieve Network Load Balancers         |
| [**datacenters\_networkloadbalancers\_flowlogs\_delete**](#datacenters_networkloadbalancers_flowlogs_delete)                                                           | **DELETE** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs/{flowLogId}               | Delete NLB Flow Logs                    |
| [**datacenters\_networkloadbalancers\_flowlogs\_find\_by\_flow\_log\_id**](#datacenters_networkloadbalancers_flowlogs_find_by_flow_log_id)                             | **GET** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs/{flowLogId}                  | Retrieve NLB Flow Logs                  |
| [**datacenters\_networkloadbalancers\_flowlogs\_get**](#datacenters_networkloadbalancers_flowlogs_get)                                                                 | **GET** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs                              | List NLB Flow Logs                      |
| [**datacenters\_networkloadbalancers\_flowlogs\_patch**](#datacenters_networkloadbalancers_flowlogs_patch)                                                             | **PATCH** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs/{flowLogId}                | Partially modify NLB Flow Logs          |
| [**datacenters\_networkloadbalancers\_flowlogs\_post**](#datacenters_networkloadbalancers_flowlogs_post)                                                               | **POST** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs                             | Create a NLB Flow Log                   |
| [**datacenters\_networkloadbalancers\_flowlogs\_put**](#datacenters_networkloadbalancers_flowlogs_put)                                                                 | **PUT** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/flowlogs/{flowLogId}                  | Modify NLB Flow Logs                    |
| [**datacenters\_networkloadbalancers\_forwardingrules\_delete**](#datacenters_networkloadbalancers_forwardingrules_delete)                                             | **DELETE** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules/{forwardingRuleId} | Delete NLB forwarding rules             |
| [**datacenters\_networkloadbalancers\_forwardingrules\_find\_by\_forwarding\_rule\_id**](#datacenters_networkloadbalancers_forwardingrules_find_by_forwarding_rule_id) | **GET** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules/{forwardingRuleId}    | Retrieve NLB forwarding rules           |
| [**datacenters\_networkloadbalancers\_forwardingrules\_get**](#datacenters_networkloadbalancers_forwardingrules_get)                                                   | **GET** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules                       | List NLB forwarding rules               |
| [**datacenters\_networkloadbalancers\_forwardingrules\_patch**](#datacenters_networkloadbalancers_forwardingrules_patch)                                               | **PATCH** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules/{forwardingRuleId}  | Partially modify NLB forwarding rules   |
| [**datacenters\_networkloadbalancers\_forwardingrules\_post**](#datacenters_networkloadbalancers_forwardingrules_post)                                                 | **POST** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules                      | Create a NLB Forwarding Rule            |
| [**datacenters\_networkloadbalancers\_forwardingrules\_put**](#datacenters_networkloadbalancers_forwardingrules_put)                                                   | **PUT** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}/forwardingrules/{forwardingRuleId}    | Modify NLB forwarding rules             |
| [**datacenters\_networkloadbalancers\_get**](#datacenters_networkloadbalancers_get)                                                                                    | **GET** /datacenters/{datacenterId}/networkloadbalancers                                                               | List Network Load Balancers             |
| [**datacenters\_networkloadbalancers\_patch**](#datacenters_networkloadbalancers_patch)                                                                                | **PATCH** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}                                     | Partially modify Network Load Balancers |
| [**datacenters\_networkloadbalancers\_post**](#datacenters_networkloadbalancers_post)                                                                                  | **POST** /datacenters/{datacenterId}/networkloadbalancers                                                              | Create a Network Load Balancer          |
| [**datacenters\_networkloadbalancers\_put**](#datacenters_networkloadbalancers_put)                                                                                    | **PUT** /datacenters/{datacenterId}/networkloadbalancers/{networkLoadBalancerId}                                       | Modify Network Load Balancers           |

## datacenters\_networkloadbalancers\_delete

> datacenters\_networkloadbalancers\_delete(datacenter\_id, network\_load\_balancer\_id, opts)

Delete Network Load Balancers

Remove the specified Network Load Balancer from the data center.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Delete Network Load Balancers
  api_instance.datacenters_networkloadbalancers_delete(datacenter_id, network_load_balancer_id, opts)
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_delete: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_delete\_with\_http\_info variant

This returns an Array which contains the response data (`nil` in this case), status code and headers.

> \<Array(nil, Integer, Hash)> datacenters\_networkloadbalancers\_delete\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, opts)

```ruby
begin
  # Delete Network Load Balancers
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_delete_with_http_info(datacenter_id, network_load_balancer_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => nil
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_delete_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

nil (empty response body)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_find\_by\_network\_load\_balancer\_id

> datacenters\_networkloadbalancers\_find\_by\_network\_load\_balancer\_id(datacenter\_id, network\_load\_balancer\_id, opts)

Retrieve Network Load Balancers

Retrieve the properties of the specified Network Load Balancer within the data center.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Retrieve Network Load Balancers
  result = api_instance.datacenters_networkloadbalancers_find_by_network_load_balancer_id(datacenter_id, network_load_balancer_id, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_find_by_network_load_balancer_id: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_find\_by\_network\_load\_balancer\_id\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_find\_by\_network\_load\_balancer\_id\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, opts)

```ruby
begin
  # Retrieve Network Load Balancers
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_find_by_network_load_balancer_id_with_http_info(datacenter_id, network_load_balancer_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <NetworkLoadBalancer>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_find_by_network_load_balancer_id_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**NetworkLoadBalancer**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/networkloadbalancer)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_delete

> datacenters\_networkloadbalancers\_flowlogs\_delete(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, opts)

Delete NLB Flow Logs

Delete the specified Network Load Balancer Flow Log.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
flow_log_id = 'flow_log_id_example' # String | The unique ID of the Flow Log.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Delete NLB Flow Logs
  api_instance.datacenters_networkloadbalancers_flowlogs_delete(datacenter_id, network_load_balancer_id, flow_log_id, opts)
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_delete: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_delete\_with\_http\_info variant

This returns an Array which contains the response data (`nil` in this case), status code and headers.

> \<Array(nil, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_delete\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, opts)

```ruby
begin
  # Delete NLB Flow Logs
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_delete_with_http_info(datacenter_id, network_load_balancer_id, flow_log_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => nil
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_delete_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **flow\_log\_id**               | **String**  | The unique ID of the Flow Log.                                                                                                                                                                                                                                                                                                                                                                                                           |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

nil (empty response body)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_find\_by\_flow\_log\_id

> datacenters\_networkloadbalancers\_flowlogs\_find\_by\_flow\_log\_id(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, opts)

Retrieve NLB Flow Logs

Retrieve the specified Network Load Balancer Flow Log.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
flow_log_id = 'flow_log_id_example' # String | The unique ID of the Flow Log.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Retrieve NLB Flow Logs
  result = api_instance.datacenters_networkloadbalancers_flowlogs_find_by_flow_log_id(datacenter_id, network_load_balancer_id, flow_log_id, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_find_by_flow_log_id: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_find\_by\_flow\_log\_id\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_find\_by\_flow\_log\_id\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, opts)

```ruby
begin
  # Retrieve NLB Flow Logs
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_find_by_flow_log_id_with_http_info(datacenter_id, network_load_balancer_id, flow_log_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <FlowLog>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_find_by_flow_log_id_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **flow\_log\_id**               | **String**  | The unique ID of the Flow Log.                                                                                                                                                                                                                                                                                                                                                                                                           |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**FlowLog**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlog)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_get

> datacenters\_networkloadbalancers\_flowlogs\_get(datacenter\_id, network\_load\_balancer\_id, opts)

List NLB Flow Logs

List all the Flow Logs for the specified Network Load Balancer.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # List NLB Flow Logs
  result = api_instance.datacenters_networkloadbalancers_flowlogs_get(datacenter_id, network_load_balancer_id, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_get: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_get\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_get\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, opts)

```ruby
begin
  # List NLB Flow Logs
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_get_with_http_info(datacenter_id, network_load_balancer_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <FlowLogs>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_get_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**FlowLogs**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlogs)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_patch

> datacenters\_networkloadbalancers\_flowlogs\_patch(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, network\_load\_balancer\_flow\_log\_properties, opts)

Partially modify NLB Flow Logs

Update the properties of the specified Network Load Balancer Flow Log.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
flow_log_id = 'flow_log_id_example' # String | The unique ID of the Flow Log.
network_load_balancer_flow_log_properties = Ionoscloud::FlowLogProperties.new({action: 'ACCEPTED', bucket: 'bucketName/key', direction: 'INGRESS', name: 'My resource'}) # FlowLogProperties | The properties of the Flow Log to be updated.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Partially modify NLB Flow Logs
  result = api_instance.datacenters_networkloadbalancers_flowlogs_patch(datacenter_id, network_load_balancer_id, flow_log_id, network_load_balancer_flow_log_properties, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_patch: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_patch\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_patch\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, network\_load\_balancer\_flow\_log\_properties, opts)

```ruby
begin
  # Partially modify NLB Flow Logs
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_patch_with_http_info(datacenter_id, network_load_balancer_id, flow_log_id, network_load_balancer_flow_log_properties, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <FlowLog>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_patch_with_http_info: #{e}"
end
```

### Parameters

| Name                                               | Type                                                                                                               | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| -------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------ | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**                                 | **String**                                                                                                         | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id**                    | **String**                                                                                                         | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **flow\_log\_id**                                  | **String**                                                                                                         | The unique ID of the Flow Log.                                                                                                                                                                                                                                                                                                                                                                                                           |                               |
| **network\_load\_balancer\_flow\_log\_properties** | [**FlowLogProperties**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlogproperties) | The properties of the Flow Log to be updated.                                                                                                                                                                                                                                                                                                                                                                                            |                               |
| **pretty**                                         | **Boolean**                                                                                                        | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                                          | **Integer**                                                                                                        | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**                            | **Integer**                                                                                                        | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**FlowLog**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlog)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_post

> datacenters\_networkloadbalancers\_flowlogs\_post(datacenter\_id, network\_load\_balancer\_id, network\_load\_balancer\_flow\_log, opts)

Create a NLB Flow Log

Adds a new Flow Log for the Network Load Balancer.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
network_load_balancer_flow_log = Ionoscloud::FlowLog.new({properties: Ionoscloud::FlowLogProperties.new({action: 'ACCEPTED', bucket: 'bucketName/key', direction: 'INGRESS', name: 'My resource'})}) # FlowLog | The Flow Log to create.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Create a NLB Flow Log
  result = api_instance.datacenters_networkloadbalancers_flowlogs_post(datacenter_id, network_load_balancer_id, network_load_balancer_flow_log, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_post: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_post\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_post\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, network\_load\_balancer\_flow\_log, opts)

```ruby
begin
  # Create a NLB Flow Log
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_post_with_http_info(datacenter_id, network_load_balancer_id, network_load_balancer_flow_log, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <FlowLog>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_post_with_http_info: #{e}"
end
```

### Parameters

| Name                                   | Type                                                                                           | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| -------------------------------------- | ---------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**                     | **String**                                                                                     | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id**        | **String**                                                                                     | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **network\_load\_balancer\_flow\_log** | [**FlowLog**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlog) | The Flow Log to create.                                                                                                                                                                                                                                                                                                                                                                                                                  |                               |
| **pretty**                             | **Boolean**                                                                                    | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                              | **Integer**                                                                                    | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**                | **Integer**                                                                                    | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**FlowLog**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlog)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## datacenters\_networkloadbalancers\_flowlogs\_put

> datacenters\_networkloadbalancers\_flowlogs\_put(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, network\_load\_balancer\_flow\_log, opts)

Modify NLB Flow Logs

Modify the specified Network Load Balancer Flow Log.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
flow_log_id = 'flow_log_id_example' # String | The unique ID of the Flow Log.
network_load_balancer_flow_log = Ionoscloud::FlowLogPut.new({properties: Ionoscloud::FlowLogProperties.new({action: 'ACCEPTED', bucket: 'bucketName/key', direction: 'INGRESS', name: 'My resource'})}) # FlowLogPut | The modified NLB Flow Log.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Modify NLB Flow Logs
  result = api_instance.datacenters_networkloadbalancers_flowlogs_put(datacenter_id, network_load_balancer_id, flow_log_id, network_load_balancer_flow_log, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_put: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_flowlogs\_put\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_flowlogs\_put\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, flow\_log\_id, network\_load\_balancer\_flow\_log, opts)

```ruby
begin
  # Modify NLB Flow Logs
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_flowlogs_put_with_http_info(datacenter_id, network_load_balancer_id, flow_log_id, network_load_balancer_flow_log, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <FlowLog>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_flowlogs_put_with_http_info: #{e}"
end
```

### Parameters

| Name                                   | Type                                                                                                 | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| -------------------------------------- | ---------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**                     | **String**                                                                                           | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id**        | **String**                                                                                           | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **flow\_log\_id**                      | **String**                                                                                           | The unique ID of the Flow Log.                                                                                                                                                                                                                                                                                                                                                                                                           |                               |
| **network\_load\_balancer\_flow\_log** | [**FlowLogPut**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlogput) | The modified NLB Flow Log.                                                                                                                                                                                                                                                                                                                                                                                                               |                               |
| **pretty**                             | **Boolean**                                                                                          | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                              | **Integer**                                                                                          | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**                | **Integer**                                                                                          | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**FlowLog**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/flowlog)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## datacenters\_networkloadbalancers\_forwardingrules\_delete

> datacenters\_networkloadbalancers\_forwardingrules\_delete(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, opts)

Delete NLB forwarding rules

Delete the specified Network Load Balancer forwarding rule.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
forwarding_rule_id = 'forwarding_rule_id_example' # String | The unique ID of the forwarding rule.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Delete NLB forwarding rules
  api_instance.datacenters_networkloadbalancers_forwardingrules_delete(datacenter_id, network_load_balancer_id, forwarding_rule_id, opts)
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_delete: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_forwardingrules\_delete\_with\_http\_info variant

This returns an Array which contains the response data (`nil` in this case), status code and headers.

> \<Array(nil, Integer, Hash)> datacenters\_networkloadbalancers\_forwardingrules\_delete\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, opts)

```ruby
begin
  # Delete NLB forwarding rules
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_forwardingrules_delete_with_http_info(datacenter_id, network_load_balancer_id, forwarding_rule_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => nil
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_delete_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **forwarding\_rule\_id**        | **String**  | The unique ID of the forwarding rule.                                                                                                                                                                                                                                                                                                                                                                                                    |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

nil (empty response body)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_forwardingrules\_find\_by\_forwarding\_rule\_id

> datacenters\_networkloadbalancers\_forwardingrules\_find\_by\_forwarding\_rule\_id(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, opts)

Retrieve NLB forwarding rules

Retrieve the specified Network Load Balance forwarding rule.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
forwarding_rule_id = 'forwarding_rule_id_example' # String | The unique ID of the forwarding rule.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Retrieve NLB forwarding rules
  result = api_instance.datacenters_networkloadbalancers_forwardingrules_find_by_forwarding_rule_id(datacenter_id, network_load_balancer_id, forwarding_rule_id, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_find_by_forwarding_rule_id: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_forwardingrules\_find\_by\_forwarding\_rule\_id\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_forwardingrules\_find\_by\_forwarding\_rule\_id\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, opts)

```ruby
begin
  # Retrieve NLB forwarding rules
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_forwardingrules_find_by_forwarding_rule_id_with_http_info(datacenter_id, network_load_balancer_id, forwarding_rule_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <NetworkLoadBalancerForwardingRule>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_find_by_forwarding_rule_id_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **forwarding\_rule\_id**        | **String**  | The unique ID of the forwarding rule.                                                                                                                                                                                                                                                                                                                                                                                                    |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**NetworkLoadBalancerForwardingRule**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/networkloadbalancerforwardingrule)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_forwardingrules\_get

> datacenters\_networkloadbalancers\_forwardingrules\_get(datacenter\_id, network\_load\_balancer\_id, opts)

List NLB forwarding rules

List the forwarding rules for the specified Network Load Balancer.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # List NLB forwarding rules
  result = api_instance.datacenters_networkloadbalancers_forwardingrules_get(datacenter_id, network_load_balancer_id, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_get: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_forwardingrules\_get\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_forwardingrules\_get\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, opts)

```ruby
begin
  # List NLB forwarding rules
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_forwardingrules_get_with_http_info(datacenter_id, network_load_balancer_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <NetworkLoadBalancerForwardingRules>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_get_with_http_info: #{e}"
end
```

### Parameters

| Name                            | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| ------------------------------- | ----------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**              | **String**  | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id** | **String**  | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **pretty**                      | **Boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                       | **Integer** | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**         | **Integer** | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

### Return type

[**NetworkLoadBalancerForwardingRules**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/networkloadbalancerforwardingrules)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## datacenters\_networkloadbalancers\_forwardingrules\_patch

> datacenters\_networkloadbalancers\_forwardingrules\_patch(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, network\_load\_balancer\_forwarding\_rule\_properties, opts)

Partially modify NLB forwarding rules

Update the properties of the specified Network Load Balancer forwarding rule.

### Examples

```ruby
require 'time'
require 'ionoscloud'
# setup authorization
Ionoscloud.configure do |config|
  # Configure HTTP basic authorization: Basic Authentication
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'

  # Configure API key authorization: Token Authentication
  config.api_key['Authorization'] = 'YOUR API KEY'
  # Uncomment the following line to set a prefix for the API key, e.g. 'Bearer' (defaults to nil)
  # config.api_key_prefix['Authorization'] = 'Bearer'
end

api_instance = Ionoscloud::NetworkLoadBalancersApi.new
datacenter_id = 'datacenter_id_example' # String | The unique ID of the data center.
network_load_balancer_id = 'network_load_balancer_id_example' # String | The unique ID of the Network Load Balancer.
forwarding_rule_id = 'forwarding_rule_id_example' # String | The unique ID of the forwarding rule.
network_load_balancer_forwarding_rule_properties = Ionoscloud::NetworkLoadBalancerForwardingRuleProperties.new({algorithm: 'ROUND_ROBIN', listener_ip: '81.173.1.2', listener_port: 8080, name: 'My Network Load Balancer forwarding rule', protocol: 'HTTP', targets: [Ionoscloud::NetworkLoadBalancerForwardingRuleTarget.new({ip: '22.231.2.2', port: 8080, weight: 123})]}) # NetworkLoadBalancerForwardingRuleProperties | The properties of the forwarding rule to be updated.
opts = {
  pretty: true, # Boolean | Controls whether the response is pretty-printed (with indentations and new lines).
  depth: 56, # Integer | Controls the detail depth of the response objects.  GET /datacenters/[ID]  - depth=0: Only direct properties are included; children (servers and other elements) are not included.  - depth=1: Direct properties and children references are included.  - depth=2: Direct properties and children properties are included.  - depth=3: Direct properties and children properties and children's children are included.  - depth=... and so on
  x_contract_number: 56 # Integer | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.
}

begin
  # Partially modify NLB forwarding rules
  result = api_instance.datacenters_networkloadbalancers_forwardingrules_patch(datacenter_id, network_load_balancer_id, forwarding_rule_id, network_load_balancer_forwarding_rule_properties, opts)
  p result
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_patch: #{e}"
end
```

#### Using the datacenters\_networkloadbalancers\_forwardingrules\_patch\_with\_http\_info variant

This returns an Array which contains the response data, status code and headers.

> \<Array(, Integer, Hash)> datacenters\_networkloadbalancers\_forwardingrules\_patch\_with\_http\_info(datacenter\_id, network\_load\_balancer\_id, forwarding\_rule\_id, network\_load\_balancer\_forwarding\_rule\_properties, opts)

```ruby
begin
  # Partially modify NLB forwarding rules
  data, status_code, headers = api_instance.datacenters_networkloadbalancers_forwardingrules_patch_with_http_info(datacenter_id, network_load_balancer_id, forwarding_rule_id, network_load_balancer_forwarding_rule_properties, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <NetworkLoadBalancerForwardingRule>
rescue Ionoscloud::ApiError => e
  puts "Error when calling NetworkLoadBalancersApi->datacenters_networkloadbalancers_forwardingrules_patch_with_http_info: #{e}"
end
```

### Parameters

| Name                                                      | Type                                                                                                                                                                   | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                         |
| --------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ----------------------------- |
| **datacenter\_id**                                        | **String**                                                                                                                                                             | The unique ID of the data center.                                                                                                                                                                                                                                                                                                                                                                                                        |                               |
| **network\_load\_balancer\_id**                           | **String**                                                                                                                                                             | The unique ID of the Network Load Balancer.                                                                                                                                                                                                                                                                                                                                                                                              |                               |
| **forwarding\_rule\_id**                                  | **String**                                                                                                                                                             | The unique ID of the forwarding rule.                                                                                                                                                                                                                                                                                                                                                                                                    |                               |
| **network\_load\_balancer\_forwarding\_rule\_properties** | [**NetworkLoadBalancerForwardingRuleProperties**](https://docs.ionos.com/sections-test/ruby-sdk/cloud-api-ruby-sdk/models/networkloadbalancerforwardingruleproperties) | The properties of the forwarding rule to be updated.                                                                                                                                                                                                                                                                                                                                                                                     |                               |
| **pretty**                                                | **Boolean**                                                                                                                                                            | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional]\[default to true] |
| **depth**                                                 | **Integer**                                                                                                                                                            | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional]\[default to 0]    |
| **x\_contract\_number**                                   | **Integer**                                                                                                                                                            | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                   |

[...]
